
CoCoALib - Design #1446

Start using C++14 "move" capability

12 Mar 2020 14:46 - John Abbott

Status: In Progress Start date: 12 Mar 2020

Priority: Normal Due date:  

Assignee:  % Done: 10%

Category: Improving Estimated time: 0.00 hour

Target version: CoCoALib-0.99880 Spent time: 0.30 hour

Description

C++14 (maybe even C++11?) offer an appealing notion of "move ctor" which avoid some deep copies.

We should adapt our impl to use this feature.  This will surely take some time (and produce little visible benefit).

Related issues:

Related to CoCoALib - Design #1225: Move to C++14 (skipping C++11) In Progress 06 Sep 2018

Related to CoCoA-5 - Design #1519: Interpreter fn Value::from can use std::move? New 26 Oct 2020

History

#1 - 12 Mar 2020 14:46 - John Abbott

- Related to Design #1225: Move to C++14 (skipping C++11) added

#2 - 12 Mar 2020 14:50 - John Abbott

We need to do this piecemeal as many different classes must be considered.  Besided modifying the class, we will probably have to insert some calls

to std::move in a few places (it could take along time to find most of these).

Here is a list of the classes we need to consider; I'll mark with "done" those which have already been updated:

BigInt (2020-07-28: added move ctor)

BigRat (2020-10-05: added move ctor)

RingElem

...

I should probably re-read Scott Meyers's book first...

PS I have set the target as 0.99720, but do not expect to finish by then; I just want to make sure that this task is not forgotten!

#3 - 02 Oct 2020 21:14 - John Abbott

- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99850

#4 - 14 Oct 2020 15:40 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

Here are some fns to consider changing:

myCharacteristic
others???

#5 - 26 Oct 2020 09:55 - John Abbott

- Related to Design #1519: Interpreter fn Value::from can use std::move? added

#6 - 08 Mar 2024 18:00 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99880
